#pragma once

#ifdef __cplusplus
#  include <cstdio>
#  include <cstring>
#  include <cstdlib>
#else
#  include <stdio.h>
#  include <string.h>
#  include <stdlib.h>
typedef unsigned char bool;
enum { false, true };
#endif
#include <stdint.h>

#define CHECK_ARGS(a,b) if(argc != a) { puts(b); return 1; }
#define CHECK_FILEGET(a,b) if(!b) { printf("Error! File %s not found\n", a); }
#define CHECK_FILEGET_DIE(a,b) if(!b) { printf("Error! File %s not found\n", a); return 2; }

#define SHORT_MAIN int main()
#define LONG_MAIN(a,b) int main(int a, char **b)
#define FULL_MAIN(a,b,c) int main(int a, char **b, char **c)

#define MIN(a,b) (a < b ? a : b)
#define MAX(a,b) (a > b ? a : b)

#define UNUSED (void)

#ifdef __cplusplus
using namespace std;
extern "C" 
{
#endif

  unsigned char *FileGetContent(const char *FileName, size_t *Size);
  unsigned char *FileGetContentAsText(const char *FileName, size_t *Size);
  bool           FileSetContent(const char *FileName, void *Data, size_t Size);

  bool           IsAlpha(int c);
  bool           IsNum(int c);
  bool           IsAlphaNum(int c);
  bool           IsHex(int c);
  bool           IsPrintable(int c);
  bool           IsWhiteChar(int c);

  int           *MakeHistogram(void *Data, size_t Size);
  float          Entropy(void *Data, size_t Size);


#ifdef __cplusplus
}
#endif

